// Generated by IcedCoffeeScript 108.0.9
var EntryList, logger;

logger = require("./logger");

EntryList = (function() {
  function EntryList() {
    this.entries = [];
  }

  EntryList.prototype.addEntry = function(domain, type, address, ttl) {
    var d, error;
    if (type == null) {
      type = "A";
    }
    if (address == null) {
      address = "127.0.0.1";
    }
    if (ttl == null) {
      ttl = 1800;
    }
    try {
      d = "^" + domain.replace(/\*/g, "\\S+").replace(/\./g, "\\.") + "$";
      this.entries.push({
        domain: domain,
        domainRegex: new RegExp(d, "i"),
        type: type,
        address: address,
        ttl: ttl
      });
      return logger.info("added domain", domain, "type", type, "address", address, "ttl", ttl, "to the local resolution entry list");
    } catch (_error) {
      error = _error;
      return logger.error(error);
    }
  };

  EntryList.prototype.addTextEntry = function(data) {
    var error, parts;
    try {
      parts = data.split(":");
      return this.addEntry(parts[0], parts[1], parts[2]);
    } catch (_error) {
      error = _error;
      return logger.error("could not parse DNS record", data, error);
    }
  };

  EntryList.prototype.findEntries = function(name) {
    var entry, _i, _len, _ref, _results;
    _ref = this.entries;
    _results = [];
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      entry = _ref[_i];
      if (entry.domainRegex.exec(name)) {
        _results.push(entry);
      }
    }
    return _results;
  };

  return EntryList;

})();

module.exports = EntryList;
